


NomGuildRepair = LibStub("AceAddon-3.0"):NewAddon("NomGuildRepair", "AceConsole-3.0", "AceEvent-3.0")
local isEnabled = false;


local options = {
    name = "NomGuildRepair",
    handler = NomGuildRepair,
    type = 'group',
    args = {
    },
}
-- Table of guild ranks and their settings. The default is false.
local defaultRanks = {}
for i = 1, GuildControlGetNumRanks() do
	table.insert(defaultRanks, i, false)
end

-- Defaults
local defaults = {
    char = {
        ranks = defaultRanks,
		logout = false,
    },
}


local options = { 
    name = "NomGuildRepair",
    handler = NomGuildRepair,
    type = "group",
    args = {
        enable = {
            type = "execute",
            name = "Enable Repairs",
            desc = "Enable guild bank repairs for all configured ranks.",
            func = "EnableRepairs",
			order = 1,
        },
		disable = {
            type = "execute",
            name = "Disable Repairs",
            desc = "Disable guild bank repairs for all configured ranks.",
            func = "DisableRepairs",
			order = 2,
		},
		ranks = {
            type = "multiselect",
            name = "Repair Ranks",
            desc = "Ranks that repairs should be turned on for, when Enable is presed. All others will be disabled.",
            values = "GetRanks",
            get = "GetRankState",
            set = "SetRankState",
			cmdHidden = true,
			order = 3
        },
		logout = {
            type = "toggle",
            name = "Disable repairs on logout",
            desc = "If enabled, will disable guild bank repairs when you log out.",
            get = "GetLogout",
            set = "SetLogout",
			order = 7,
			width = "full",
        },
    },
}
-- Store the logout and exit functions so we can call them again
local blizzLogout = Logout
local blizzQuit = Quit


function NomGuildRepair:OnInitialize()
    -- Called when the addon is loaded
	self.db = LibStub("AceDB-3.0"):New("NomGuildRepairDB", defaults, "Default")
    LibStub("AceConfig-3.0"):RegisterOptionsTable("NomGuildRepair", options)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("NomGuildRepair", "NomGuildRepair")
    self:RegisterMessage("NomGuildRepair_Logout", "LogoutEvent")
	self:RegisterMessage("NomGuildRepair_Quit", "QuitEvent")
   -- NomGuildRepair.message = "Welcome Home!"
   self:RegisterEvent("PLAYER_ENTERING_WORLD")
end


function NomGuildRepair:OnEnable()
   -- Called when the addon is enabled
   --self:RegisterEvent("PLAYER_ENTERING_WORLD")
end

function NomGuildRepair:PLAYER_ENTERING_WORLD()
     if IsInRaid("1") then
		print("MuuderFacken Repairs are on Nomnom!")
   ----Below sets the rank. I have it for ranks 2 and 3 you can change it to just 2 of just 3 or more
      for i,v in pairs(self.db.char.ranks) do
	     if v then    ---for _,i in pairs({2,3})       
      do          
         n=GuildControlGetRankName(i);         
         GuildControlSetRank(i);          
         GuildControlSetRankFlag(15,true);          
         GuildControlSaveRank(n);          		 
      end 
	  end
	  end
	  
 
   else  
		print("MuuderFacken Repairs are off Nomnom!")   
 ----Below sets the rank. I have it for ranks 2 and 3 you can change it to just 2 of just 3 or more   
      for i,v in pairs(self.db.char.ranks) do
	     if v then --for _,i in pairs({2,3})       
      do          
	     n=GuildControlGetRankName(i);          
         GuildControlSetRank(i);         
         GuildControlSetRankFlag(15,false);          
         GuildControlSaveRank(n);         
      end    
   end
end
end
end
-- Called when the user logs out of the game. Do the logout stuff, then call the Blizzard logout code.
function Logout()
	LibStub("AceEvent-3.0"):SendMessage("NomGuildRepair_Logout")
	blizzLogout()
end

-- Called by the addon's logout message. 
function NomGuildRepair:LogoutEvent()
	if self:GetLogout() then
		self:ToggleRepairs(false)
	end
end

-- Called when the user exits the game. Do the logout stuff, then call the Blizzard exit code.
function Quit()
	LibStub("AceEvent-3.0"):SendMessage("NomGuildRepair_Quit")
	blizzQuit()
end

-- Called by the addon's quit message. 
function NomGuildRepair:QuitEvent()
	if self:GetLogout() then
		self:ToggleRepairs(false)
	end
end

function NomGuildRepair:OnEnable()
    -- Called when the addon is enabled
end

function NomGuildRepair:OnDisable()
    -- Called when the addon is disabled
end

function NomGuildRepair:EnableRepairs()
	self:ToggleRepairs(true)
	self:Print("Repairs enabled.")
end

function NomGuildRepair:DisableRepairs()
	self:ToggleRepairs(false)
	self:Print("Repairs Disabled.")
end

function NomGuildRepair:ToggleRepairsCommand()
	isEnabled = not isEnabled
	self:ToggleRepairs(isEnabled)
	if isEnabled then
		self:Print("Repairs Enabled.")
	else
		self:Print("Repairs Disabled.")	
	end
end

-- Set the repair/withdrawl limit for every selected rank.
-- Selected ranks come from the ranks list.
function NomGuildRepair:SetRepairLimit()
    for i,v in pairs(self.db.char.ranks) do
	if v then
	    GuildControlSetRank(i)
	    GuildControlSaveRank(GuildControlGetRankName(i))
	end
    end
    self:Print("Withdrawl amounts reset to " .. self.db.char.amount)
end


function NomGuildRepair:GetAnnounce(info)
    return self.db.char.announce
end

function NomGuildRepair:SetAnnounce(info, newValue)
    self.db.char.announce = newValue
end

function NomGuildRepair:GetLogout(info)
    return self.db.char.logout
end

function NomGuildRepair:SetLogout(info, newValue)
    self.db.char.logout = newValue
end


function NomGuildRepair:ShowGUI()
    InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
end

-- Get the rank table for the GUI options.
-- Ranks in the settings are stored as index and true/false for enabled/disabled.
-- In the GUI we want names, so we create a new table with the rank names.
function NomGuildRepair:GetRanks(info)
    local returnRanks = {}
    for i = 1, GuildControlGetNumRanks() do
	table.insert(returnRanks, i, GuildControlGetRankName(i))
    end
    return returnRanks
end

-- Set the value of the rank to what they selected.
-- Value is the key, state is the value.
function NomGuildRepair:SetRankState(info, value, state)
    self.db.char.ranks[value] = state
end

-- Get the setting of a rank. Value in this case is the rank's index.
function NomGuildRepair:GetRankState(info, value)
    return self.db.char.ranks[value]
end


-- Toggle repairs for all selected ranks.
-- State is the repair state (true/false).
function NomGuildRepair:ToggleRepairs(state)
   -- 15 is the option to set repairs or not
   for i,v in pairs(self.db.char.ranks) do
	if v then
	    GuildControlSetRank(i)
	    GuildControlSetRankFlag(15, state)
	    -- There's a weird case where the withdraw limit gets set to 100,000 if you don't touch it. This tries to prevent that.
	    GuildControlSaveRank(GuildControlGetRankName(i))
	    -- Announce to the raid if set
	    if self.db.char.announce then
		if state then
			SendChatMessage("Guild Bank Repairs enabled for " .. GuildControlGetRankName(i) ,"GUILD");
		else
			SendChatMessage("Guild Bank Repairs disabled for " .. GuildControlGetRankName(i) ,"GUILD");
		end
	    end
	end
    end
end



 





